
;SEVERAL VARIABLES USED THROUGHOUT SEVERAL FUNCTIONS. MOST MIMIC THE Z80 REGISTERS.
z_HL equ z_Regs
z_L  equ z_Regs
z_H  equ z_Regs+1

z_BC equ z_Regs+2
z_C  equ z_Regs+2
z_B  equ z_Regs+3

z_DE equ z_Regs+4
z_E  equ z_Regs+4
z_D  equ z_Regs+5

z_As equ z_Regs+6
z_Hs equ z_Regs+7

z_ixl equ z_Regs+8
z_ixh equ z_Regs+9
z_ix equ z_Regs+8


z_iyl equ z_Regs+10
z_iyh equ z_Regs+11
z_iy  equ z_Regs+10

printhex:
        pha
                clc
                and #%11110000
                ror
                ror
                ror
                ror
                jsr printhexAgain
        pla
        pha
                and #%00001111
                jsr printhexAgain
        pla
        rts
printhexAgain
        cmp #10
        bcs printhex_OverNine
        clc
        adc #'0'
        jsr PrintChar
        rts
printhex_OverNine
        clc
        adc #55
        ;'adc #'A'
        jsr PrintChar
        rts

    
;THIS IS THE CUNTION FOR PRINTING TEXT ON THE SCREEN
PrintString
        LDY #0
PrintString_again
        LDA (z_HL),y
        
		CMP #255				;IF A 255 IS FOUND, DONE PRINTING STRING
        BEQ PrintString_Done
		CMP #CR					;IF A CARRIAGE RETURN IS FOUND, PRINT A NEW LINE
		BEQ PrintString_Enter
		
		; I'M GOING TO ABUSE $DB TO $DF TO MOVE THE CURSORX LOCATION. (MOVE X 10 WITH EACH)
		CMP #$DB
		BNE PRINTCHECKX2		;IF NOT EQUAL, HOP OVER TO THE NEXT CHECK
		LDA #9
		STA CursorX				;SET THE CURSORX POSITION TO 10
		INY						;NEXT CHARACTER
		JMP PrintString_again	;GO PRINT THE NEXT CHARACTER
PRINTCHECKX2
		CMP #$DC
		BNE PRINTCHECKX3		;IF NOT EQUAL, HOP OVER TO THE NEXT CHECK
		LDA #19
		STA CursorX				;SET THE CURSORX POSITION TO 20
		INY						;NEXT CHARACTER
		JMP PrintString_again	;GO PRINT THE NEXT CHARACTER
PRINTCHECKX3
		CMP #$DD
		BNE PRINTCHECKXDONE		;IF NOT EQUAL, HOP OVER TO THE NEXT CHECK
		LDA #29
		STA CursorX				;SET THE CURSORX POSITION TO 30
		INY						;NEXT CHARACTER
		JMP PrintString_again	;GO PRINT THE NEXT CHARACTER

PRINTCHECKXDONE		
		; I'M ABUSING THE PETSCII CHARACTERS FOR Y LINE CHANGES,
		; CHARACTERS $E0 TO $FB WILL SET THE CURSORY LINE FROM 0-27 
		; CHECK IF THE CHARACTER TO PRINT IS $E0 OR HIGHER. THEN
		CMP #$E0				;CHECK IF THE CHARACTER'S VALUE IS $E0
		BCC	PRINTTHECHAR		;BRANCH IF THE CHARACTER'S VALUE IS LESS THEN $E0, JUST PRINT THE CHARACTER AT THAT POINT.
		SEC
		SBC	#224				;SUBTRACT 224 FROM THE CHARACTERS VALUE ($E0)
		JMP PrintString_ChangeLineDo	;JUMP TO PrintString_ChangeLineDo
		
PRINTTHECHAR
        JSR PrintChar			;OTHERWISE PRINT CHARACTER		
        INY
        JMP PrintString_again
PrintString_Done
        RTS
PrintString_Enter
		JSR newline				;PRINT A NEW LINE AND RETURN TO PRINT THE NEXT CHARACTER
		INY
		JMP PrintString_again
		
		
PrintString_ChangeLineDo
		STA CursorY				;CHANGE CURSOR Y TO THE VALUE IN A
		STZ CursorX				;RESET CURSOR X TO 0
		
		;NOW WIPE THE WHOLE LINE WITH BLANK SPACES
		LDX #0
PSCSRLOOP
		LDA #' '
		JSR PrintChar			;PRINT SPACEBAR
		INX
		CPX #40					;CHECK IF 40 CHARACTERS HAVE BEEN PRINTED ON THE LINE ALREADY
		BEQ PSCSRLOOPY
		BRA	PSCSRLOOP		;OTHERWISE PRINT AGAIN
PSCSRLOOPY						;DONE WIPING THE LINE
		LDX CursorY
		DEX
		STX CursorY				;WITH THE WIPING THE Y CURSOR WENT DOWN ONE, PUT THE CURSOR BACK UP 1 LINE
		
		INY
		JMP PrintString_again	;AND READ/PRINT NEXT CHARACTER