;Usage:
;        jsr MemDump
;        word $CEED      ;Address
;        byte $3          ;Lines
monitor_memdump:
MemDump

        pha
        txa
        pha
        tya
        pha
        tay
                ;jsr Monitor
                tsx
              
                ;jsr Monitor
                
                lda SPpage+$04,x
                sta t_RetAddrL
                ;jsr Monitor
                lda SPpage+$05,x
                sta t_RetAddrH
                ;jsr Monitor

                ldy #1
                lda (t_RetAddr),Y
                sta t_MemdumpL
                ;jsr Monitor
        
                iny
                lda (t_RetAddr),Y
                sta t_MemdumpH
                ;jsr Monitor
        
                iny
                lda (t_RetAddr),Y
                
                tax  
                jsr MemDumpDirectB

                tsx
                inc SPpage+$04,x
                inc SPpage+$04,x
                inc SPpage+$04,x
				
				
                lda SPpage+$04,x
                cmp #3
                bcs MemDump_NoIncSpH
				inc SPpage+$05,x
MemDump_NoIncSpH
        pla
		tay
        pla
        tax
        pla

		
        rts

MemDumpDirect
        ldy #8
MemDumpDirectB
        lda t_MemdumpH
        sta t_MemdumpBH
        jsr printhex
        lda t_MemdumpL
        sta t_MemdumpBL
        jsr printhex

        lda #":"
        jsr PrintChar
        jsr NewLine

        ldy #0
MemDump_Again
		;jsr Monitor

        tya
        pha
MemDump_AgainHex
                lda (t_MemdumpL),y

                jsr printhex
                lda #" "
                jsr PrintChar
                iny
                tya
                and #%00000111
                bne MemDump_AgainHex
        pla
        tay
MemDump_AgainChar
        lda (t_MemdumpBL),y
        cmp #32
        Bcc MemDump_BadChar
        cmp #128
        Bcs MemDump_BadChar
MemDump_AgainCharRet
        
        jsr PrintChar

        iny
        tya
        and #%00000111
        bne MemDump_AgainChar
		ifndef BuildNES
		ifndef BuildPCE
		ifndef BuildSNS
			jsr NewLine
		endif
		endif
		endif
MemDump_CarryOn
		
        dex
        bne MemDump_Again
			
        rts
MemDump_BadChar
        lda #"."
        jmp MemDump_AgainCharRet
		
		
		
Monitor

	php ;and push the status of the cpu flags again, to resume monitor as before.
	
		sta t_A
		pushpair z_bc
		lda t_a
		pha											
		
		;Print Accumulator data
				lda #"a"
				jsr printmonitorchar
		pla											
		pha     ;Push A
		jsr printmonitorhex
		
		
		txa     ;ld a,x69696						
		pha     ;push

		tya     ;ld a,y
		pha     ;push

	  ;  tsx     ;LD X,SP
	
		;Print X register data
		lda #"x"
		jsr printmonitorchar
		txa
		jsr printmonitorhex

		;Print Y register data
		lda #"y"
		jsr printmonitorchar
		tya
		jsr printmonitorhex

		;Print Stack pointer data
		lda #"s"
		jsr printmonitorchar	;print the letter S to screen.

		tsx		;transfer stack pointer to X
		txa		;transfer stack pointer from X to A
		clc		;clear carry
		adc #6	;add 6 to the stack pointer in A
		jsr printmonitorhex	;print the stack pointer to screen.
		

		lda #"p";Print Program Counter data to screen
		jsr printmonitorchar
		tsx			;take the stack pointer in X
		txa			;transfer stack pointer to A
		clc			;clear carry
		adc #7		;add 7 to the stack pointer.
		pha					;push A to stack				(flags = stack 4)
				tax
				lda SPpage+$01,x	;take major byte and print to screen
				jsr printhex
		pla					;take A from the stack again.	(flags = stack 3)
		tax
		lda SPpage+$00,x		;take minor byte and print to screen.
		jsr printhex
		
		Jsr NewLine				;go to a new line.
		
		;print processor Flags.
		lda #"f"
		jsr printmonitorchar
		;get cpu flags, binary order is NV-BDIZC
		tsx
		txa
		clc
		adc #6
		tax
		lda SPpage+$00,x	;get the cpu flags from stack, at position 6

		pha					;put the cpu flags on the stack for the next check		
		AND #$80			;test flag bit 8 = Negative
		BNE FlagBit8Set
		BEQ FlagBit8Clear
FlagBit8Set
		lda #"N"			;print N on screen
		jsr PrintChar
		jmp FlagBit8Done
FlagBit8Clear
		jsr FlagPrintDash
FlagBit8Done

		pla
		pha					;get the cpu flags from the stack and put them right back on it again.
		AND #$40			;test flag bit 7 = overFlow
		BNE FlagBit7Set
		BEQ FlagBit7Clear
FlagBit7Set
		lda #"V"			;print V on screen
		jsr PrintChar
		jmp FlagBit7Done
FlagBit7Clear
		jsr FlagPrintDash
FlagBit7Done

		;bit 6 is not used, always print a -
		jsr FlagPrintDash

		pla
		pha					;get the cpu flags from the stack and put them right back on it again.
		AND #$10			;test flag bit 5 = Break
		BNE FlagBit5Set
		BEQ FlagBit5Clear
FlagBit5Set
		lda #"B"			;print B on screen
		jsr PrintChar
		jmp FlagBit5Done
FlagBit5Clear
		jsr FlagPrintDash
FlagBit5Done

		pla
		pha					;get the cpu flags from the stack and put them right back on it again.
		AND #$08			;test flag bit 4 = Decimal
		BNE FlagBit4Set
		BEQ FlagBit4Clear
FlagBit4Set
		lda #"D"			;print D on screen
		jsr PrintChar
		jmp FlagBit4Done
FlagBit4Clear
		jsr FlagPrintDash
FlagBit4Done

		pla
		pha					;get the cpu flags from the stack and put them right back on it again.
		AND #$04			;test flag bit 3 = Irq disable
		BNE FlagBit3Set
		BEQ FlagBit3Clear
FlagBit3Set
		lda #"I"			;print I on screen
		jsr PrintChar
		jmp FlagBit3Done
FlagBit3Clear
		jsr FlagPrintDash
FlagBit3Done

		pla
		pha					;get the cpu flags from the stack and put them right back on it again.
		AND #$02			;test flag bit 2 = Zero
		BNE FlagBit2Set
		BEQ FlagBit2Clear
FlagBit2Set
		lda #"Z"			;print Z on screen
		jsr PrintChar
		jmp FlagBit2Done
FlagBit2Clear
		jsr FlagPrintDash
FlagBit2Done

		pla
		pha					;get the cpu flags from the stack and put them right back on it again.
		AND #$01			;test flag bit 1 = Carry
		BNE FlagBit1Set
		BEQ FlagBit1Clear
FlagBit1Set
		lda #"C"			;print I on screen
		jsr PrintChar
		jmp FlagBit1Done
FlagBit1Clear
		jsr FlagPrintDash
FlagBit1Done

		lda #" "			;print - on screen
		jsr PrintChar
		pla						;get the cpu flags from the stack for the last time.
		jsr printmonitorhex		;print the cpu flags in HEX to screen as well.
		
		Jsr NewLine			;and go to a new line.

		pla
		tay
		pla
		tax
		
		pla     ;Pop A
		
		sta t_A
		pullpair z_bc
		lda t_a
	plp     ;Pop F
		
	rts
printmonitorchar
	jsr PrintChar
	lda #":"
	jmp PrintChar
printmonitorhex
	jsr printhex
	lda #" "
	jmp PrintChar
   
FlagPrintDash
	lda #"-"			;print - on screen
	jsr PrintChar
	rts
